//Create message handler instance when each player joins game
object_event_add(PlayerControl, ev_step, ev_step_begin, "
	if !instance_exists(gg2iMessageHandler)
		instance_create(0, 0, gg2iMessageHandler);
");

//Message Handling
if !variable_global_exists('gg2iMessageHandler')
{
	globalvar gg2iMessageHandler;
	gg2iMessageHandler = object_add();
	object_event_add(gg2iMessageHandler, ev_step, ev_step_end, "
		//Host processing message
		if (global.isHost)
		{
			while(PluginPacketGetBuffer(gg2i.packetID) != -1)
			{
				_buffer = PluginPacketGetBuffer(gg2i.packetID);
				_player = PluginPacketGetPlayer(gg2i.packetID);
				if (_player == -1 || !instance_exists(_player))
					break;
				switch(read_ubyte(_buffer))
				{
					//User say hello with own item loadout
					case 0:
						//Send other players sender's loadout info
						key_size = read_ubyte(_buffer);
						if (key_size == 0)
							key = '';
						else
							key = read_string(_buffer, key_size);
						loadout_str = read_string(_buffer, buffer_size(_buffer));
						_player.key = key;
						
						ds_list_destroy(_player.gg2i_head_list);
						ds_list_destroy(_player.gg2i_torso_list);
						ds_list_destroy(_player.gg2i_leg_list);
						ds_list_destroy(_player.gg2i_weapon_list);
						ds_list_destroy(_player.gg2i_misc_list);
						ds_list_destroy(_player.gg2i_taunt_list);
						ds_list_destroy(_player.gg2i_pet_list);
						ds_list_destroy(_player.gg2i_death_list);
						ds_list_destroy(_player.gg2i_humiliation_list);
						_player.gg2i_title = '';
						
						item_lists = split(loadout_str, ';');
						_player.gg2i_head_list = split(ds_list_find_value(item_lists, 0), ',');
						_player.gg2i_torso_list = split(ds_list_find_value(item_lists, 1), ',');
						_player.gg2i_leg_list = split(ds_list_find_value(item_lists, 2), ',');
						_player.gg2i_weapon_list = split(ds_list_find_value(item_lists, 3), ',');
						_player.gg2i_misc_list = split(ds_list_find_value(item_lists, 4), ',');
						_player.gg2i_taunt_list = split(ds_list_find_value(item_lists, 5), ',');
						_player.gg2i_pet_list = split(ds_list_find_value(item_lists, 6), ',');
						_player.gg2i_death_list = split(ds_list_find_value(item_lists, 7), ',');
						_player.gg2i_humiliation_list = split(ds_list_find_value(item_lists, 8), ',');
						_player.gg2i_title = ds_list_find_value(item_lists, 9);
						_player.gg2i_item_got = true;
						_player.gg2i_item_set = false;
						if (key == '')
							_player.is_gg2s_user = false;
						else
							_player.is_gg2s_user = true;
						ds_list_destroy(item_lists);
						
						//Unusual
						for (i = 0; i < 10; i += 1)
						{
							_player.gg2i_unusual[i] = -1;
							if (string_count('+', ds_list_find_value(_player.gg2i_head_list, i)) > 0)
							{
								temp_list = split(ds_list_find_value(_player.gg2i_head_list, i), '+');
								ds_list_replace(_player.gg2i_head_list, i, ds_list_find_value(temp_list, 0));
								_player.gg2i_unusual[i] = real(ds_list_find_value(temp_list, 1));
								ds_list_destroy(temp_list);
							}
						}
						
						//Strange
						for (i = 0; i < 10; i += 1)
						{
							_player.gg2i_strange_type[i] = -1;
							_player.gg2i_strange_count[i] = 0;
							if (string_count('+', ds_list_find_value(_player.gg2i_weapon_list, i)) > 0)
							{
								temp_list = split(ds_list_find_value(_player.gg2i_weapon_list, i), '+');
								temp_list2 = split(ds_list_find_value(temp_list, 1), '-');
								ds_list_replace(_player.gg2i_weapon_list, i, ds_list_find_value(temp_list, 0));
								_player.gg2i_strange_type[i] = real(ds_list_find_value(temp_list2, 0));
								_player.gg2i_strange_count[i] = real(ds_list_find_value(temp_list2, 1));
								ds_list_destroy(temp_list);
								ds_list_destroy(temp_list2);
							}
						}
						
						//Send other players new challenger's loadout
						write_ubyte(gg2i.messageBuffer, 0);
						write_ubyte(gg2i.messageBuffer, ds_list_find_index(global.players, _player));
						write_ubyte(gg2i.messageBuffer, _player.is_gg2s_user);
						write_string(gg2i.messageBuffer, loadout_str);
						PluginPacketSend(gg2i.packetID, gg2i.messageBuffer);
						buffer_clear(gg2i.messageBuffer);
						
						//Send new challenger other players loadout info
						for(i = 0; i < ds_list_size(global.players); i += 1)
						{
							paramPlayer = ds_list_find_value(global.players, i);
							write_ubyte(gg2i.messageBuffer, 0);
							write_ubyte(gg2i.messageBuffer, i);
							write_ubyte(gg2i.messageBuffer, paramPlayer.is_gg2s_user);
							gg2i_loadout_list = ds_list_create();
							gg2i_head_list = paramPlayer.gg2i_head_list;
							gg2i_torso_list = paramPlayer.gg2i_torso_list;
							gg2i_leg_list = paramPlayer.gg2i_leg_list;
							gg2i_weapon_list = paramPlayer.gg2i_weapon_list;
							gg2i_misc_list = paramPlayer.gg2i_misc_list;
							gg2i_taunt_list = paramPlayer.gg2i_taunt_list;
							gg2i_pet_list = paramPlayer.gg2i_pet_list;
							gg2i_death_list = paramPlayer.gg2i_death_list;
							gg2i_humiliation_list = paramPlayer.gg2i_humiliation_list;
							ds_list_add(gg2i_loadout_list, gg2i_head_list);
							ds_list_add(gg2i_loadout_list, gg2i_torso_list);
							ds_list_add(gg2i_loadout_list, gg2i_leg_list);
							ds_list_add(gg2i_loadout_list, gg2i_weapon_list);
							ds_list_add(gg2i_loadout_list, gg2i_misc_list);
							ds_list_add(gg2i_loadout_list, gg2i_taunt_list);
							ds_list_add(gg2i_loadout_list, gg2i_pet_list);
							ds_list_add(gg2i_loadout_list, gg2i_death_list);
							ds_list_add(gg2i_loadout_list, gg2i_humiliation_list);
							loadout_str = '';
							for (j = 0; j < ds_list_size(gg2i_loadout_list); j += 1)
							{
								for (k = 0; k < 10; k += 1)
								{
									loadout_str += ds_list_find_value(ds_list_find_value(gg2i_loadout_list, j), k);
									if (j == 0)
									{
										if (paramPlayer.gg2i_unusual[k] != -1)
											loadout_str += '+' + string(paramPlayer.gg2i_unusual[k]);
									}
									else if (j == 3)
									{
										if (paramPlayer.gg2i_strange_type[k] != -1)
										{
											loadout_str += '+' + string(paramPlayer.gg2i_strange_type[k]);
											loadout_str += '-' + string(paramPlayer.gg2i_strange_count[k]);
										}
									}
									if (k < 9)
										loadout_str += ',';
								}
								loadout_str += ';';
							}
							loadout_str += paramPlayer.gg2i_title;
							paramPlayer = -1;
							write_string(gg2i.messageBuffer, loadout_str);
							PluginPacketSendTo(gg2i.packetID, gg2i.messageBuffer, _player);
							buffer_clear(gg2i.messageBuffer);
						}
						break;
					//User change loadout
					case 1:
						//THIS WILL NOT USED AS LOADOUT CHANGE
						break;
					//Received Bubble Information
					case 2:
						bubbleImage = read_ubyte(_buffer);
						if(instance_exists(_player)) {
							if(_player.object != -1) {
								if (_player.object.invisible)
									exit;
								_player.object.bubble.image_index = bubbleImage;
								_player.object.bubble.alarm[0] = 60 / global.delta_factor;
								_player.object.bubble.visible = true;
								_player.object.bubble.bubbleAlpha = 2;
								_player.object.bubble.fadeout = false;
							}
						}
						write_ubyte(gg2i.messageBuffer, 2);
						write_ubyte(gg2i.messageBuffer, ds_list_find_index(global.players, _player));
						write_ubyte(gg2i.messageBuffer, bubbleImage);
						buffer_clear(gg2i.messageBuffer);
						break;
				}
				buffer_clear(_buffer);
				PluginPacketPop(gg2i.packetID);
			}
		}
		//Client receiving message
		else
		{
			while(PluginPacketGetBuffer(gg2i.packetID) != -1)
			{
				loadoutReceiveBuffer = PluginPacketGetBuffer(gg2i.packetID);
				switch(read_ubyte(loadoutReceiveBuffer))
				{
					case 0:
						playerId = read_ubyte(loadoutReceiveBuffer);
						_player = ds_list_find_value(global.players, playerId);
						_player.is_gg2s_user = read_ubyte(loadoutReceiveBuffer);
						loadout_str = read_string(loadoutReceiveBuffer, buffer_size(loadoutReceiveBuffer));
						
						ds_list_destroy(_player.gg2i_head_list);
						ds_list_destroy(_player.gg2i_torso_list);
						ds_list_destroy(_player.gg2i_leg_list);
						ds_list_destroy(_player.gg2i_weapon_list);
						ds_list_destroy(_player.gg2i_misc_list);
						ds_list_destroy(_player.gg2i_taunt_list);
						ds_list_destroy(_player.gg2i_pet_list);
						ds_list_destroy(_player.gg2i_death_list);
						ds_list_destroy(_player.gg2i_humiliation_list);
						_player.gg2i_title = '';
						
						item_lists = split(loadout_str, ';');
						_player.gg2i_head_list = split(ds_list_find_value(item_lists, 0), ',');
						_player.gg2i_torso_list = split(ds_list_find_value(item_lists, 1), ',');
						_player.gg2i_leg_list = split(ds_list_find_value(item_lists, 2), ',');
						_player.gg2i_weapon_list = split(ds_list_find_value(item_lists, 3), ',');
						_player.gg2i_misc_list = split(ds_list_find_value(item_lists, 4), ',');
						_player.gg2i_taunt_list = split(ds_list_find_value(item_lists, 5), ',');
						_player.gg2i_pet_list = split(ds_list_find_value(item_lists, 6), ',');
						_player.gg2i_death_list = split(ds_list_find_value(item_lists, 7), ',');
						_player.gg2i_humiliation_list = split(ds_list_find_value(item_lists, 8), ',');
						_player.gg2i_title = ds_list_find_value(item_lists, 9);
						_player.gg2i_item_got = true;
						_player.gg2i_item_set = false;
						ds_list_destroy(item_lists);
						
						//Unusual
						for (i = 0; i < 10; i += 1)
						{
							_player.gg2i_unusual[i] = -1;
							if (string_count('+', ds_list_find_value(_player.gg2i_head_list, i)) > 0)
							{
								temp_list = split(ds_list_find_value(_player.gg2i_head_list, i), '+');
								ds_list_replace(_player.gg2i_head_list, i, ds_list_find_value(temp_list, 0));
								_player.gg2i_unusual[i] = real(ds_list_find_value(temp_list, 1));
								ds_list_destroy(temp_list);
							}
						}
						
						//Strange
						for (i = 0; i < 10; i += 1)
						{
							_player.gg2i_strange_type[i] = -1;
							_player.gg2i_strange_count[i] = 0;
							if (string_count('+', ds_list_find_value(_player.gg2i_weapon_list, i)) > 0)
							{
								temp_list = split(ds_list_find_value(_player.gg2i_weapon_list, i), '+');
								temp_list2 = split(ds_list_find_value(temp_list, 1), '-');
								ds_list_replace(_player.gg2i_weapon_list, i, ds_list_find_value(temp_list, 0));
								_player.gg2i_strange_type[i] = real(ds_list_find_value(temp_list2, 0));
								_player.gg2i_strange_count[i] = real(ds_list_find_value(temp_list2, 1));
								ds_list_destroy(temp_list);
								ds_list_destroy(temp_list2);
							}
						}
						buffer_clear(loadoutReceiveBuffer);
						PluginPacketPop(gg2i.packetID);
						break;

					//Receiving Present Position
					case 1:
						pos_x = read_ushort(loadoutReceiveBuffer)/5;
						pos_y = read_ushort(loadoutReceiveBuffer)/5;
						present = instance_create(pos_x, pos_y, gg2i_item_present);
						present.team = read_ubyte(loadoutReceiveBuffer);
						present.image_index = 2*present.team;
						buffer_clear(loadoutReceiveBuffer);
						PluginPacketPop(gg2i.packetID);
						break;
						
					//Receiving Bubble Information
					case 2:
						playerId = read_ubyte(loadoutReceiveBuffer);
						bubbleImage = read_ubyte(loadoutReceiveBuffer);
						_player = ds_list_find_value(global.players, playerId);
						if(instance_exists(_player)) {
							if(_player.object != -1) {
								if (_player.object.invisible)
									exit;
								_player.object.bubble.image_index = bubbleImage;
								_player.object.bubble.alarm[0] = 60 / global.delta_factor;
								_player.object.bubble.visible = true;
								_player.object.bubble.bubbleAlpha = 2;
								_player.object.bubble.fadeout = false;
							}
						}
						buffer_clear(loadoutReceiveBuffer);
						PluginPacketPop(gg2i.packetID);
						break;
				}
			}
		}
	");
	
	//Send users position of present(Server)
	object_event_add(gg2iMessageHandler, ev_other, ev_user0, "
		write_ubyte(gg2i.messageBuffer, 1);
		write_ushort(gg2i.messageBuffer, present.x*5);
		write_ushort(gg2i.messageBuffer, present.y*5);
		write_ubyte(gg2i.messageBuffer, present.team);
		PluginPacketSend(gg2i.packetID, gg2i.messageBuffer);
		buffer_clear(gg2i.messageBuffer);
		present = -1;
	");
}